diff --git a/dlls/dinput/dinput_main.c b/dlls/dinput/dinput_main.c
index 5d75cdf56e9..4a57947532e 100644
--- a/dlls/dinput/dinput_main.c
+++ b/dlls/dinput/dinput_main.c
@@ -57,7 +57,6 @@ WINE_DEFAULT_DEBUG_CHANNEL(dinput);
 
 static const IDirectInput7AVtbl ddi7avt;
 static const IDirectInput7WVtbl ddi7wvt;
-static const IDirectInput8AVtbl ddi8avt;
 static const IDirectInput8WVtbl ddi8wvt;
 static const IDirectInputJoyConfig8Vtbl JoyConfig8vt;
 
@@ -71,11 +70,6 @@ static inline IDirectInputImpl *impl_from_IDirectInput7W( IDirectInput7W *iface
     return CONTAINING_RECORD( iface, IDirectInputImpl, IDirectInput7W_iface );
 }
 
-static inline IDirectInputImpl *impl_from_IDirectInput8A( IDirectInput8A *iface )
-{
-    return CONTAINING_RECORD( iface, IDirectInputImpl, IDirectInput8A_iface );
-}
-
 static inline IDirectInputImpl *impl_from_IDirectInput8W( IDirectInput8W *iface )
 {
     return CONTAINING_RECORD( iface, IDirectInputImpl, IDirectInput8W_iface );
@@ -144,7 +138,7 @@ static HRESULT create_directinput_instance(REFIID riid, LPVOID *ppDI, IDirectInp
 
     This->IDirectInput7A_iface.lpVtbl = &ddi7avt;
     This->IDirectInput7W_iface.lpVtbl = &ddi7wvt;
-    This->IDirectInput8A_iface.lpVtbl = &ddi8avt;
+    This->IDirectInput8A_iface.lpVtbl = &direct_input_8_a_vtbl;
     This->IDirectInput8W_iface.lpVtbl = &ddi8wvt;
     This->IDirectInputJoyConfig8_iface.lpVtbl = &JoyConfig8vt;
 
@@ -321,110 +315,6 @@ static void _dump_EnumDevices_dwFlags(DWORD dwFlags)
     TRACE("\n");
 }
 
-static void _dump_diactionformatA(LPDIACTIONFORMATA lpdiActionFormat)
-{
-    unsigned int i;
-
-    TRACE("diaf.dwSize = %d\n", lpdiActionFormat->dwSize);
-    TRACE("diaf.dwActionSize = %d\n", lpdiActionFormat->dwActionSize);
-    TRACE("diaf.dwDataSize = %d\n", lpdiActionFormat->dwDataSize);
-    TRACE("diaf.dwNumActions = %d\n", lpdiActionFormat->dwNumActions);
-    TRACE("diaf.rgoAction = %p\n", lpdiActionFormat->rgoAction);
-    TRACE("diaf.guidActionMap = %s\n", debugstr_guid(&lpdiActionFormat->guidActionMap));
-    TRACE("diaf.dwGenre = 0x%08x\n", lpdiActionFormat->dwGenre);
-    TRACE("diaf.dwBufferSize = %d\n", lpdiActionFormat->dwBufferSize);
-    TRACE("diaf.lAxisMin = %d\n", lpdiActionFormat->lAxisMin);
-    TRACE("diaf.lAxisMax = %d\n", lpdiActionFormat->lAxisMax);
-    TRACE("diaf.hInstString = %p\n", lpdiActionFormat->hInstString);
-    TRACE("diaf.ftTimeStamp ...\n");
-    TRACE("diaf.dwCRC = 0x%x\n", lpdiActionFormat->dwCRC);
-    TRACE("diaf.tszActionMap = %s\n", debugstr_a(lpdiActionFormat->tszActionMap));
-    for (i = 0; i < lpdiActionFormat->dwNumActions; i++)
-    {
-        TRACE("diaf.rgoAction[%u]:\n", i);
-        TRACE("\tuAppData=0x%lx\n", lpdiActionFormat->rgoAction[i].uAppData);
-        TRACE("\tdwSemantic=0x%08x\n", lpdiActionFormat->rgoAction[i].dwSemantic);
-        TRACE("\tdwFlags=0x%x\n", lpdiActionFormat->rgoAction[i].dwFlags);
-        TRACE("\tszActionName=%s\n", debugstr_a(lpdiActionFormat->rgoAction[i].u.lptszActionName));
-        TRACE("\tguidInstance=%s\n", debugstr_guid(&lpdiActionFormat->rgoAction[i].guidInstance));
-        TRACE("\tdwObjID=0x%x\n", lpdiActionFormat->rgoAction[i].dwObjID);
-        TRACE("\tdwHow=0x%x\n", lpdiActionFormat->rgoAction[i].dwHow);
-    }
-}
-
-void _copy_diactionformatAtoW(LPDIACTIONFORMATW to, LPDIACTIONFORMATA from)
-{
-    int i;
-
-    to->dwSize = sizeof(DIACTIONFORMATW);
-    to->dwActionSize = sizeof(DIACTIONW);
-    to->dwDataSize = from->dwDataSize;
-    to->dwNumActions = from->dwNumActions;
-    to->guidActionMap = from->guidActionMap;
-    to->dwGenre = from->dwGenre;
-    to->dwBufferSize = from->dwBufferSize;
-    to->lAxisMin = from->lAxisMin;
-    to->lAxisMax = from->lAxisMax;
-    to->dwCRC = from->dwCRC;
-    to->ftTimeStamp = from->ftTimeStamp;
-
-    for (i=0; i < to->dwNumActions; i++)
-    {
-        to->rgoAction[i].uAppData = from->rgoAction[i].uAppData;
-        to->rgoAction[i].dwSemantic = from->rgoAction[i].dwSemantic;
-        to->rgoAction[i].dwFlags = from->rgoAction[i].dwFlags;
-        to->rgoAction[i].guidInstance = from->rgoAction[i].guidInstance;
-        to->rgoAction[i].dwObjID = from->rgoAction[i].dwObjID;
-        to->rgoAction[i].dwHow = from->rgoAction[i].dwHow;
-    }
-}
-
-void _copy_diactionformatWtoA(LPDIACTIONFORMATA to, LPDIACTIONFORMATW from)
-{
-    int i;
-
-    to->dwSize = sizeof(DIACTIONFORMATA);
-    to->dwActionSize = sizeof(DIACTIONA);
-    to->dwDataSize = from->dwDataSize;
-    to->dwNumActions = from->dwNumActions;
-    to->guidActionMap = from->guidActionMap;
-    to->dwGenre = from->dwGenre;
-    to->dwBufferSize = from->dwBufferSize;
-    to->lAxisMin = from->lAxisMin;
-    to->lAxisMax = from->lAxisMax;
-    to->dwCRC = from->dwCRC;
-    to->ftTimeStamp = from->ftTimeStamp;
-
-    for (i=0; i < to->dwNumActions; i++)
-    {
-        to->rgoAction[i].uAppData = from->rgoAction[i].uAppData;
-        to->rgoAction[i].dwSemantic = from->rgoAction[i].dwSemantic;
-        to->rgoAction[i].dwFlags = from->rgoAction[i].dwFlags;
-        to->rgoAction[i].guidInstance = from->rgoAction[i].guidInstance;
-        to->rgoAction[i].dwObjID = from->rgoAction[i].dwObjID;
-        to->rgoAction[i].dwHow = from->rgoAction[i].dwHow;
-    }
-}
-
-/* diactionformat_priority
- *
- *  Given a DIACTIONFORMAT structure and a DI genre, returns the enumeration
- *  priority. Joysticks should pass the game genre, and mouse or keyboard their
- *  respective DI*_MASK
- */
-static DWORD diactionformat_priorityA(LPDIACTIONFORMATA lpdiaf, DWORD genre)
-{
-    int i;
-    DWORD priorityFlags = 0;
-
-    /* If there's at least one action for the device it's priority 1 */
-    for(i=0; i < lpdiaf->dwNumActions; i++)
-        if ((lpdiaf->rgoAction[i].dwSemantic & genre) == genre)
-            priorityFlags |= DIEDBS_MAPPEDPRI1;
-
-    return priorityFlags;
-}
-
 static DWORD diactionformat_priorityW(LPDIACTIONFORMATW lpdiaf, DWORD genre)
 {
     int i;
@@ -910,97 +800,53 @@ static HRESULT WINAPI IDirectInputWImpl_CreateDevice(LPDIRECTINPUT7W iface, REFG
  *      DirectInput8
  */
 
-static ULONG WINAPI IDirectInput8AImpl_AddRef(LPDIRECTINPUT8A iface)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput8A( iface );
-    return IDirectInputAImpl_AddRef( &This->IDirectInput7A_iface );
-}
-
 static ULONG WINAPI IDirectInput8WImpl_AddRef(LPDIRECTINPUT8W iface)
 {
     IDirectInputImpl *This = impl_from_IDirectInput8W( iface );
-    return IDirectInputAImpl_AddRef( &This->IDirectInput7A_iface );
-}
-
-static HRESULT WINAPI IDirectInput8AImpl_QueryInterface(LPDIRECTINPUT8A iface, REFIID riid, LPVOID *ppobj)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput8A( iface );
-    return IDirectInputAImpl_QueryInterface( &This->IDirectInput7A_iface, riid, ppobj );
+    return IDirectInput7_AddRef(&This->IDirectInput7W_iface);
 }
 
 static HRESULT WINAPI IDirectInput8WImpl_QueryInterface(LPDIRECTINPUT8W iface, REFIID riid, LPVOID *ppobj)
 {
     IDirectInputImpl *This = impl_from_IDirectInput8W( iface );
-    return IDirectInputAImpl_QueryInterface( &This->IDirectInput7A_iface, riid, ppobj );
-}
-
-static ULONG WINAPI IDirectInput8AImpl_Release(LPDIRECTINPUT8A iface)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput8A( iface );
-    return IDirectInputAImpl_Release( &This->IDirectInput7A_iface );
+    return IDirectInput7_QueryInterface(&This->IDirectInput7W_iface, riid, ppobj);
 }
 
 static ULONG WINAPI IDirectInput8WImpl_Release(LPDIRECTINPUT8W iface)
 {
     IDirectInputImpl *This = impl_from_IDirectInput8W( iface );
-    return IDirectInputAImpl_Release( &This->IDirectInput7A_iface );
-}
-
-static HRESULT WINAPI IDirectInput8AImpl_CreateDevice(LPDIRECTINPUT8A iface, REFGUID rguid,
-                                                      LPDIRECTINPUTDEVICE8A* pdev, LPUNKNOWN punk)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput8A( iface );
-    return IDirectInput7AImpl_CreateDeviceEx(&This->IDirectInput7A_iface, rguid, &IID_IDirectInputDeviceA, (LPVOID *)pdev, punk);
+    return IDirectInput7_Release(&This->IDirectInput7W_iface);
 }
 
 static HRESULT WINAPI IDirectInput8WImpl_CreateDevice(LPDIRECTINPUT8W iface, REFGUID rguid,
                                                       LPDIRECTINPUTDEVICE8W* pdev, LPUNKNOWN punk)
 {
     IDirectInputImpl *This = impl_from_IDirectInput8W( iface );
-    return IDirectInput7WImpl_CreateDeviceEx(&This->IDirectInput7W_iface, rguid, &IID_IDirectInputDeviceW, (LPVOID *)pdev, punk);
-}
-
-static HRESULT WINAPI IDirectInput8AImpl_EnumDevices(LPDIRECTINPUT8A iface, DWORD dwDevType, LPDIENUMDEVICESCALLBACKA lpCallback,
-                                                     LPVOID pvRef, DWORD dwFlags)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput8A( iface );
-    return IDirectInputAImpl_EnumDevices( &This->IDirectInput7A_iface, dwDevType, lpCallback, pvRef, dwFlags );
+    return IDirectInput7_CreateDeviceEx(&This->IDirectInput7W_iface, rguid, &IID_IDirectInputDeviceW, (LPVOID *)pdev, punk);
 }
 
 static HRESULT WINAPI IDirectInput8WImpl_EnumDevices(LPDIRECTINPUT8W iface, DWORD dwDevType, LPDIENUMDEVICESCALLBACKW lpCallback,
                                                      LPVOID pvRef, DWORD dwFlags)
 {
     IDirectInputImpl *This = impl_from_IDirectInput8W( iface );
-    return IDirectInputWImpl_EnumDevices( &This->IDirectInput7W_iface, dwDevType, lpCallback, pvRef, dwFlags );
-}
-
-static HRESULT WINAPI IDirectInput8AImpl_GetDeviceStatus(LPDIRECTINPUT8A iface, REFGUID rguid)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput8A( iface );
-    return IDirectInputAImpl_GetDeviceStatus( &This->IDirectInput7A_iface, rguid );
+    return IDirectInput7_EnumDevices(&This->IDirectInput7W_iface, dwDevType, lpCallback, pvRef, dwFlags);
 }
 
 static HRESULT WINAPI IDirectInput8WImpl_GetDeviceStatus(LPDIRECTINPUT8W iface, REFGUID rguid)
 {
     IDirectInputImpl *This = impl_from_IDirectInput8W( iface );
-    return IDirectInputAImpl_GetDeviceStatus( &This->IDirectInput7A_iface, rguid );
-}
-
-static HRESULT WINAPI IDirectInput8AImpl_RunControlPanel(LPDIRECTINPUT8A iface, HWND hwndOwner, DWORD dwFlags)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput8A( iface );
-    return IDirectInputAImpl_RunControlPanel( &This->IDirectInput7A_iface, hwndOwner, dwFlags );
+    return IDirectInput7_GetDeviceStatus(&This->IDirectInput7W_iface, rguid);
 }
 
 static HRESULT WINAPI IDirectInput8WImpl_RunControlPanel(LPDIRECTINPUT8W iface, HWND hwndOwner, DWORD dwFlags)
 {
     IDirectInputImpl *This = impl_from_IDirectInput8W( iface );
-    return IDirectInputAImpl_RunControlPanel( &This->IDirectInput7A_iface, hwndOwner, dwFlags );
+    return IDirectInput7_RunControlPanel(&This->IDirectInput7W_iface, hwndOwner, dwFlags);
 }
 
-static HRESULT WINAPI IDirectInput8AImpl_Initialize(LPDIRECTINPUT8A iface, HINSTANCE hinst, DWORD version)
+static HRESULT WINAPI IDirectInput8WImpl_Initialize(LPDIRECTINPUT8W iface, HINSTANCE hinst, DWORD version)
 {
-    IDirectInputImpl *This = impl_from_IDirectInput8A( iface );
+    IDirectInputImpl *This = impl_from_IDirectInput8W(iface);
 
     TRACE("(%p)->(%p, 0x%04x)\n", This, hinst, version);
 
@@ -1016,18 +862,6 @@ static HRESULT WINAPI IDirectInput8AImpl_Initialize(LPDIRECTINPUT8A iface, HINST
     return initialize_directinput_instance(This, version);
 }
 
-static HRESULT WINAPI IDirectInput8WImpl_Initialize(LPDIRECTINPUT8W iface, HINSTANCE hinst, DWORD version)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput8W( iface );
-    return IDirectInput8AImpl_Initialize( &This->IDirectInput8A_iface, hinst, version );
-}
-
-static HRESULT WINAPI IDirectInput8AImpl_FindDevice(LPDIRECTINPUT8A iface, REFGUID rguid, LPCSTR pszName, LPGUID pguidInstance)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput8A( iface );
-    return IDirectInput2AImpl_FindDevice( &This->IDirectInput7A_iface, rguid, pszName, pguidInstance );
-}
-
 static HRESULT WINAPI IDirectInput8WImpl_FindDevice(LPDIRECTINPUT8W iface, REFGUID rguid, LPCWSTR pszName, LPGUID pguidInstance)
 {
     IDirectInputImpl *This = impl_from_IDirectInput8W( iface );
@@ -1075,130 +909,6 @@ static BOOL should_enumerate_device(const WCHAR *username, DWORD dwFlags,
     return should_enumerate;
 }
 
-static HRESULT WINAPI IDirectInput8AImpl_EnumDevicesBySemantics(
-      LPDIRECTINPUT8A iface, LPCSTR ptszUserName, LPDIACTIONFORMATA lpdiActionFormat,
-      LPDIENUMDEVICESBYSEMANTICSCBA lpCallback,
-      LPVOID pvRef, DWORD dwFlags
-)
-{
-    static REFGUID guids[2] = { &GUID_SysKeyboard, &GUID_SysMouse };
-    static const DWORD actionMasks[] = { DIKEYBOARD_MASK, DIMOUSE_MASK };
-    IDirectInputImpl *This = impl_from_IDirectInput8A( iface );
-    DIDEVICEINSTANCEA didevi;
-    LPDIRECTINPUTDEVICE8A lpdid;
-    DWORD callbackFlags;
-    int i, j;
-    int device_count = 0;
-    int remain;
-    DIDEVICEINSTANCEA *didevis = 0;
-    WCHAR *username_w = 0;
-
-    FIXME("(this=%p,%s,%p,%p,%p,%04x): semi-stub\n", This, debugstr_a(ptszUserName), lpdiActionFormat,
-          lpCallback, pvRef, dwFlags);
-#define X(x) if (dwFlags & x) FIXME("\tdwFlags |= "#x"\n");
-	X(DIEDBSFL_ATTACHEDONLY)
-	X(DIEDBSFL_THISUSER)
-	X(DIEDBSFL_FORCEFEEDBACK)
-	X(DIEDBSFL_AVAILABLEDEVICES)
-	X(DIEDBSFL_MULTIMICEKEYBOARDS)
-	X(DIEDBSFL_NONGAMINGDEVICES)
-#undef X
-
-    _dump_diactionformatA(lpdiActionFormat);
-
-    didevi.dwSize = sizeof(didevi);
-
-    if (ptszUserName)
-    {
-        int len = MultiByteToWideChar(CP_ACP, 0, ptszUserName, -1, 0, 0);
-
-        username_w = HeapAlloc(GetProcessHeap(), 0, sizeof(WCHAR)*len);
-        MultiByteToWideChar(CP_ACP, 0, ptszUserName, -1, username_w, len);
-    }
-
-    /* Enumerate all the joysticks */
-    for (i = 0; i < ARRAY_SIZE(dinput_devices); i++)
-    {
-        HRESULT enumSuccess;
-
-        if (!dinput_devices[i]->enum_deviceA) continue;
-
-        for (j = 0, enumSuccess = S_OK; SUCCEEDED(enumSuccess); j++)
-        {
-            TRACE(" - checking device %u ('%s')\n", i, dinput_devices[i]->name);
-
-            /* Default behavior is to enumerate attached game controllers */
-            enumSuccess = dinput_devices[i]->enum_deviceA(DI8DEVCLASS_GAMECTRL, DIEDFL_ATTACHEDONLY | dwFlags, &didevi, This->dwVersion, j);
-            if (enumSuccess == S_OK &&
-                should_enumerate_device(username_w, dwFlags, &This->device_players, &didevi.guidInstance))
-            {
-                if (device_count++)
-                    didevis = HeapReAlloc(GetProcessHeap(), 0, didevis, sizeof(DIDEVICEINSTANCEA)*device_count);
-                else
-                    didevis = HeapAlloc(GetProcessHeap(), 0, sizeof(DIDEVICEINSTANCEA)*device_count);
-                didevis[device_count-1] = didevi;
-            }
-        }
-    }
-
-    remain = device_count;
-    /* Add keyboard and mouse to remaining device count */
-    if (!(dwFlags & DIEDBSFL_FORCEFEEDBACK))
-    {
-        for (i = 0; i < ARRAY_SIZE(guids); i++)
-        {
-            if (should_enumerate_device(username_w, dwFlags, &This->device_players, guids[i]))
-                remain++;
-        }
-    }
-
-    for (i = 0; i < device_count; i++)
-    {
-        callbackFlags = diactionformat_priorityA(lpdiActionFormat, lpdiActionFormat->dwGenre);
-        IDirectInput_CreateDevice(iface, &didevis[i].guidInstance, &lpdid, NULL);
-
-        if (lpCallback(&didevis[i], lpdid, callbackFlags, --remain, pvRef) == DIENUM_STOP)
-        {
-            IDirectInputDevice_Release(lpdid);
-            HeapFree(GetProcessHeap(), 0, didevis);
-            HeapFree(GetProcessHeap(), 0, username_w);
-            return DI_OK;
-        }
-        IDirectInputDevice_Release(lpdid);
-    }
-
-    HeapFree(GetProcessHeap(), 0, didevis);
-
-    if (dwFlags & DIEDBSFL_FORCEFEEDBACK)
-    {
-        HeapFree(GetProcessHeap(), 0, username_w);
-        return DI_OK;
-    }
-
-    /* Enumerate keyboard and mouse */
-    for (i = 0; i < ARRAY_SIZE(guids); i++)
-    {
-        if (should_enumerate_device(username_w, dwFlags, &This->device_players, guids[i]))
-        {
-            callbackFlags = diactionformat_priorityA(lpdiActionFormat, actionMasks[i]);
-
-            IDirectInput_CreateDevice(iface, guids[i], &lpdid, NULL);
-            IDirectInputDevice_GetDeviceInfo(lpdid, &didevi);
-
-            if (lpCallback(&didevi, lpdid, callbackFlags, --remain, pvRef) == DIENUM_STOP)
-            {
-                IDirectInputDevice_Release(lpdid);
-                HeapFree(GetProcessHeap(), 0, username_w);
-                return DI_OK;
-            }
-            IDirectInputDevice_Release(lpdid);
-        }
-    }
-
-    HeapFree(GetProcessHeap(), 0, username_w);
-    return DI_OK;
-}
-
 static HRESULT WINAPI IDirectInput8WImpl_EnumDevicesBySemantics(
       LPDIRECTINPUT8W iface, LPCWSTR ptszUserName, LPDIACTIONFORMATW lpdiActionFormat,
       LPDIENUMDEVICESBYSEMANTICSCBW lpCallback,
@@ -1304,54 +1014,6 @@ static HRESULT WINAPI IDirectInput8WImpl_ConfigureDevices(
     return _configure_devices(iface, lpdiCallback, lpdiCDParams, dwFlags, pvRefData);
 }
 
-static HRESULT WINAPI IDirectInput8AImpl_ConfigureDevices(
-      LPDIRECTINPUT8A iface, LPDICONFIGUREDEVICESCALLBACK lpdiCallback,
-      LPDICONFIGUREDEVICESPARAMSA lpdiCDParams, DWORD dwFlags, LPVOID pvRefData
-)
-{
-    IDirectInputImpl *This = impl_from_IDirectInput8A(iface);
-    DIACTIONFORMATW diafW;
-    DICONFIGUREDEVICESPARAMSW diCDParamsW;
-    HRESULT hr;
-    int i;
-
-     FIXME("(this=%p,%p,%p,%04x,%p): stub\n", This, lpdiCallback, lpdiCDParams, dwFlags, pvRefData);
-
-    /* Copy parameters */
-    diCDParamsW.dwSize = sizeof(DICONFIGUREDEVICESPARAMSW);
-    diCDParamsW.dwcFormats = lpdiCDParams->dwcFormats;
-    diCDParamsW.lprgFormats = &diafW;
-    diCDParamsW.hwnd = lpdiCDParams->hwnd;
-
-    diafW.rgoAction = HeapAlloc(GetProcessHeap(), 0, sizeof(DIACTIONW)*lpdiCDParams->lprgFormats->dwNumActions);
-    _copy_diactionformatAtoW(&diafW, lpdiCDParams->lprgFormats);
-
-    /* Copy action names */
-    for (i=0; i < diafW.dwNumActions; i++)
-    {
-        const char* from = lpdiCDParams->lprgFormats->rgoAction[i].u.lptszActionName;
-        int len = MultiByteToWideChar(CP_ACP, 0, from , -1, NULL , 0);
-        WCHAR *to = HeapAlloc(GetProcessHeap(), 0, sizeof(WCHAR)*len);
-
-        MultiByteToWideChar(CP_ACP, 0, from , -1, to , len);
-        diafW.rgoAction[i].u.lptszActionName = to;
-    }
-
-    hr = IDirectInput8WImpl_ConfigureDevices(&This->IDirectInput8W_iface, lpdiCallback, &diCDParamsW, dwFlags, pvRefData);
-
-    /* Copy back configuration */
-    if (SUCCEEDED(hr))
-        _copy_diactionformatWtoA(lpdiCDParams->lprgFormats, &diafW);
-
-    /* Free memory */
-    for (i=0; i < diafW.dwNumActions; i++)
-        HeapFree(GetProcessHeap(), 0, (void*) diafW.rgoAction[i].u.lptszActionName);
-
-    HeapFree(GetProcessHeap(), 0, diafW.rgoAction);
-
-    return hr;
-}
-
 /*****************************************************************************
  * IDirectInputJoyConfig8 interface
  */
@@ -1364,19 +1026,19 @@ static inline IDirectInputImpl *impl_from_IDirectInputJoyConfig8(IDirectInputJoy
 static HRESULT WINAPI JoyConfig8Impl_QueryInterface(IDirectInputJoyConfig8 *iface, REFIID riid, void** ppobj)
 {
     IDirectInputImpl *This = impl_from_IDirectInputJoyConfig8( iface );
-    return IDirectInputAImpl_QueryInterface( &This->IDirectInput7A_iface, riid, ppobj );
+    return IDirectInput7_QueryInterface(&This->IDirectInput7A_iface, riid, ppobj);
 }
 
 static ULONG WINAPI JoyConfig8Impl_AddRef(IDirectInputJoyConfig8 *iface)
 {
     IDirectInputImpl *This = impl_from_IDirectInputJoyConfig8( iface );
-    return IDirectInputAImpl_AddRef( &This->IDirectInput7A_iface );
+    return IDirectInput7_AddRef(&This->IDirectInput7A_iface);
 }
 
 static ULONG WINAPI JoyConfig8Impl_Release(IDirectInputJoyConfig8 *iface)
 {
     IDirectInputImpl *This = impl_from_IDirectInputJoyConfig8( iface );
-    return IDirectInputAImpl_Release( &This->IDirectInput7A_iface );
+    return IDirectInput7_Release(&This->IDirectInput7A_iface);
 }
 
 static HRESULT WINAPI JoyConfig8Impl_Acquire(IDirectInputJoyConfig8 *iface)
@@ -1539,20 +1201,6 @@ static const IDirectInput7WVtbl ddi7wvt = {
     IDirectInput7WImpl_CreateDeviceEx
 };
 
-static const IDirectInput8AVtbl ddi8avt = {
-    IDirectInput8AImpl_QueryInterface,
-    IDirectInput8AImpl_AddRef,
-    IDirectInput8AImpl_Release,
-    IDirectInput8AImpl_CreateDevice,
-    IDirectInput8AImpl_EnumDevices,
-    IDirectInput8AImpl_GetDeviceStatus,
-    IDirectInput8AImpl_RunControlPanel,
-    IDirectInput8AImpl_Initialize,
-    IDirectInput8AImpl_FindDevice,
-    IDirectInput8AImpl_EnumDevicesBySemantics,
-    IDirectInput8AImpl_ConfigureDevices
-};
-
 static const IDirectInput8WVtbl ddi8wvt = {
     IDirectInput8WImpl_QueryInterface,
     IDirectInput8WImpl_AddRef,
diff --git a/dlls/dinput/dinput_private.h b/dlls/dinput/dinput_private.h
index ac967af4e8a..07be7b2dd8d 100644
--- a/dlls/dinput/dinput_private.h
+++ b/dlls/dinput/dinput_private.h
@@ -49,6 +49,8 @@ struct IDirectInputImpl
     struct list                 device_players; /* device instance guid to player name */
 };
 
+extern const IDirectInput8AVtbl direct_input_8_a_vtbl DECLSPEC_HIDDEN;
+
 typedef struct IDirectInputDeviceImpl IDirectInputDeviceImpl;
 
 /* Function called by all devices that Wine supports */
@@ -83,9 +85,6 @@ extern void dinput_mouse_rawinput_hook( IDirectInputDevice8W *iface, WPARAM wpar
 extern void check_dinput_hooks(LPDIRECTINPUTDEVICE8W, BOOL) DECLSPEC_HIDDEN;
 extern void check_dinput_events(void) DECLSPEC_HIDDEN;
 
-extern void _copy_diactionformatAtoW(LPDIACTIONFORMATW, LPDIACTIONFORMATA) DECLSPEC_HIDDEN;
-extern void _copy_diactionformatWtoA(LPDIACTIONFORMATA, LPDIACTIONFORMATW) DECLSPEC_HIDDEN;
-
 extern HRESULT _configure_devices(IDirectInput8W *iface, LPDICONFIGUREDEVICESCALLBACK lpdiCallback, LPDICONFIGUREDEVICESPARAMSW lpdiCDParams, DWORD dwFlags, LPVOID pvRefData) DECLSPEC_HIDDEN;
 
 extern WCHAR* get_mapping_path(const WCHAR *device, const WCHAR *username) DECLSPEC_HIDDEN;
-- 
2.28.0

>From 5129ef74aecd6aaaa7e8b4320c6cd04d33ea3c63 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 12:44:47 +0200
Subject: [PATCH 07/39] dinput: Factor IDirectInput7A implementation.

As a wrapper around IDirectInput7W interface, and use it consistently.
---
 dlls/dinput/ansi.c           | 115 +++++++++++++++++++++++++
 dlls/dinput/dinput_main.c    | 161 ++++-------------------------------
 dlls/dinput/dinput_private.h |   1 +
 3 files changed, 131 insertions(+), 146 deletions(-)

diff --git a/dlls/dinput/ansi.c b/dlls/dinput/ansi.c
index c2bd088ae6a..a3d49802b7c 100644
--- a/dlls/dinput/ansi.c
+++ b/dlls/dinput/ansi.c
@@ -49,6 +49,19 @@ static inline IDirectInputDevice8A *IDirectInputDevice8A_from_IDirectInputDevice
     if (!iface) return NULL;
     return &CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface)->IDirectInputDevice8A_iface;
 }
+static inline IDirectInputDeviceA *IDirectInputDeviceA_from_IDirectInputDeviceW(IDirectInputDeviceW *iface)
+{
+    return (IDirectInputDeviceA *)IDirectInputDevice8A_from_IDirectInputDevice8W((IDirectInputDevice8W *)iface);
+}
+
+static IDirectInputImpl *impl_from_IDirectInput7A(IDirectInput7A *iface)
+{
+    return CONTAINING_RECORD(iface, IDirectInputImpl, IDirectInput7A_iface);
+}
+static IDirectInput7W *IDirectInput7W_from_impl(IDirectInputImpl *This)
+{
+    return &This->IDirectInput7W_iface;
+}
 static IDirectInputImpl *impl_from_IDirectInput8A(IDirectInput8A *iface)
 {
     return CONTAINING_RECORD(iface, IDirectInputImpl, IDirectInput8A_iface);
@@ -775,3 +788,105 @@ const IDirectInput8AVtbl direct_input_8_a_vtbl =
     direct_input_8_a_EnumDevicesBySemantics,
     direct_input_8_a_ConfigureDevices,
 };
+
+static HRESULT STDMETHODCALLTYPE direct_input_7_a_QueryInterface(IDirectInput7A *iface, REFIID iid, void **out)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput7A(iface);
+    TRACE("iface %p, iid %s, out %p.\n", iface, debugstr_guid(iid), out);
+    return IDirectInput7_QueryInterface(IDirectInput7W_from_impl(This), iid, out);
+}
+
+static ULONG STDMETHODCALLTYPE direct_input_7_a_AddRef(IDirectInput7A *iface)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput7A(iface);
+    TRACE("iface %p.\n", iface);
+    return IDirectInput7_AddRef(IDirectInput7W_from_impl(This));
+}
+
+static ULONG STDMETHODCALLTYPE direct_input_7_a_Release(IDirectInput7A *iface)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput7A(iface);
+    TRACE("iface %p.\n", iface);
+    return IDirectInput7_Release(IDirectInput7W_from_impl(This));
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_7_a_CreateDevice(IDirectInput7A *iface, REFGUID guid,
+        IDirectInputDeviceA **out, IUnknown *outer)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput7A(iface);
+    IDirectInputDeviceW *outw;
+    HRESULT hr;
+    TRACE("iface %p, guid %s, out %p, outer %p.\n", iface, debugstr_guid(guid), out, outer);
+    if (!out) return E_POINTER;
+    hr = IDirectInput7_CreateDevice(IDirectInput7W_from_impl(This), guid, &outw, outer);
+    *out = IDirectInputDeviceA_from_IDirectInputDeviceW(outw);
+    return hr;
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_7_a_EnumDevices(IDirectInput7A *iface, DWORD type,
+        LPDIENUMDEVICESCALLBACKA callback, void *ref, DWORD flags)
+{
+    struct direct_input_a_enum_devices_params params = {callback, ref};
+    IDirectInputImpl *This = impl_from_IDirectInput7A(iface);
+    TRACE("iface %p, callback %p, ref %p, flags %#x.\n", iface, callback, ref, flags);
+    if (!callback) return DIERR_INVALIDPARAM;
+    return IDirectInput7_EnumDevices(IDirectInput7W_from_impl(This), type, direct_input_a_enum_devices_callback, &params, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_7_a_GetDeviceStatus(IDirectInput7A *iface, REFGUID instance_guid)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput7A(iface);
+    TRACE("iface %p, instance_guid %s.\n", iface, debugstr_guid(instance_guid));
+    return IDirectInput7_GetDeviceStatus(IDirectInput7W_from_impl(This), instance_guid);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_7_a_RunControlPanel(IDirectInput7A *iface, HWND owner, DWORD flags)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput7A(iface);
+    TRACE("iface %p, owner %p, flags %#x.\n", iface, owner, flags);
+    return IDirectInput7_RunControlPanel(IDirectInput7W_from_impl(This), owner, flags);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_7_a_Initialize(IDirectInput7A *iface, HINSTANCE instance, DWORD version)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput7A(iface);
+    TRACE("iface %p, instance %p, version %#x.\n", iface, instance, version);
+    return IDirectInput7_Initialize(IDirectInput7W_from_impl(This), instance, version);
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_7_a_FindDevice(IDirectInput7A *iface, REFGUID guid, const char *name, GUID *instance_guid)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput7A(iface);
+    WCHAR *namew = string_atow(name);
+    HRESULT hr;
+    TRACE("iface %p, guid %p, name %s, instance_guid %p.\n", iface, debugstr_guid(guid), debugstr_a(name), instance_guid);
+    hr = IDirectInput7_FindDevice(IDirectInput7W_from_impl(This), guid, namew, instance_guid);
+    HeapFree(GetProcessHeap(), 0, namew);
+    return hr;
+}
+
+static HRESULT STDMETHODCALLTYPE direct_input_7_a_CreateDeviceEx(IDirectInput7A *iface, REFGUID guid, REFIID iid,
+        void **out, IUnknown *outer)
+{
+    IDirectInputImpl *This = impl_from_IDirectInput7A(iface);
+    TRACE("iface %p, guid %s, iid %s, out %p, outer %p.\n", iface, debugstr_guid(guid), debugstr_guid(iid), out, outer);
+    return IDirectInput7_CreateDeviceEx(IDirectInput7W_from_impl(This), guid, iid, out, outer);
+}
+
+const IDirectInput7AVtbl direct_input_7_a_vtbl =
+{
+    /*** IUnknown methods ***/
+    direct_input_7_a_QueryInterface,
+    direct_input_7_a_AddRef,
+    direct_input_7_a_Release,
+    /*** IDirectInputA methods ***/
+    direct_input_7_a_CreateDevice,
+    direct_input_7_a_EnumDevices,
+    direct_input_7_a_GetDeviceStatus,
+    direct_input_7_a_RunControlPanel,
+    direct_input_7_a_Initialize,
+    /*** IDirectInput2A methods ***/
+    direct_input_7_a_FindDevice,
+    /*** IDirectInput7A methods ***/
+    direct_input_7_a_CreateDeviceEx,
+};
